#include <sys/tty.h>


int _clist_sense( struct clist *clp )
{
	return clp->c_cc;
}


int _clist_flush( struct clist *clp )
{
	clp->c_cc = 0;
	clp->c_cf = clp->c_cs;
	clp->c_cl = clp->c_cs;

	return 0;
}


int _clist_push( struct clist *clp , char ch )
{
	unsigned char *wp;


	if ( clp->c_cc >= clp->c_cn )	/* counttȂG[ */
		return -1;

	wp = clp->c_cl;					/* wp = load point */
	*wp++ = ch;

	if( wp >= clp->c_ce )			/* wp  buffer ̏I? */
		wp = clp->c_cs;				/* Ȃ擪 */

	clp->c_cl = wp;					/* load point XV */
	clp->c_cc++;					/* count 𑝂₷ */

	return 0;
}

int _clist_pop( struct clist *clp )
{
	unsigned char *rp,ch;

	if ( clp->c_cc == 0 )			/* buffer Ȃ return */
		return -1;

	rp = clp->c_cl;					/* rp = load point */

	if( rp <= clp->c_cs )			/* rp  buffer ̐擪? */
		rp = clp->c_ce;				/* Ȃ疖[ */

	ch = *--rp;						/* rp 1炵ēǂ݂ */

	clp->c_cl = rp;					/* load point XV */
	clp->c_cc--;					/* count 炷 */

	return ch;
}



int _clist_shift( struct clist *clp )
{
	unsigned char *rp,ch;

	if ( clp->c_cc == 0 )			/* buffer Ȃ return */
		return -1;

	rp = clp->c_cf;					/* rp = fetch point */
	ch = *rp++;						/* 1ǂ */

	if( rp >= clp->c_ce )			/* rp  buffer ̏I? */
		rp = clp->c_cs;				/* Ȃ擪 */

	clp->c_cf = rp;					/* fetch point XV */
	clp->c_cc--;					/* count 炷 */

	return ch;
}




int _clist_unshift( struct clist *clp , char ch )
{
	unsigned char *wp;


	if ( clp->c_cc >= clp->c_cn )	/* counttȂG[ */
		return -1;

	wp = clp->c_cf;					/* wp = fetch point */

	if( wp <= clp->c_cs )			/* wp  buffer ̐擪? */
		wp = clp->c_ce;				/* Ȃ疖[ */

	*--wp = ch;						/* wp 1炵ď */

	clp->c_cf = wp;					/* fetch point XV */
	clp->c_cc++;					/* count 𑝂₷ */

	return 0;
}

