.include iocscall.mac
.include doscall.mac
.include fefunc.h

.include ryos.mac
.request libr.a


.text
.even

IDSIZE = 8

head:
ID:
	.dc.b	'TTYD0000'
libcttywork::
	.include	readtty.inc
tail:


entry::
	tst.b	(a2)
	beq	keep

	cmpi.b	#'-',1(a2)
	bne	usage
	cmpi.b	#'r',2(a2)
	bne	usage
remove:
	pea.l	keep_chk
	DOS	__SUPER_JSR
	addq.l	#4,sp
	tst.l	d0
	bne	9f

	PRINTS	<'sttyd͏풓Ă܂',$0d,$0a,0>
	DOS	__EXIT

9:
	move.l	d0,d5

	PEAS	<'TTY',0>
	move.w	#5,-(sp)
	DOS	__COMMON
	addq.l	#6,sp

	add.l	#$10,d5
	move.l	d5,-(sp)		; 
	DOS	__MFREE
	addq.l	#4,sp

	PRINTS	<'sttyd풓܂',$0d,$0a,0>
	DOS	__EXIT

usage:
	PRINTS	<'usage: sttyd [-r]',$0d,$0a,0>
	DOS	__EXIT


keep:
	PEAS	<'TTY',0>
	clr.w	-(sp)
	DOS	__COMMON
	addq.l	#6,sp
	tst.l	d0
	bmi	stty_non_exist

	PRINTS	<' TTY ̖O common area o^Ă܂',$0d,$0a,0>
	DOS	__EXIT


stty_non_exist:
	move.l	#common_image_end-common_image,-(sp)
	pea.l	(common_image,pc)
	clr.l	-(sp)
	PEAS	<'TTY',0>
	move.w	#2,-(sp)
	DOS	__COMMON
	lea.l	18(sp),sp
	tst.l	d0
	bmi	common_error


	lea.l	(head,pc),a0
	lea.l	(tail,pc),a1
	sub.l	a0,a1

	clr.w	-(sp)
	pea.l	(a1)
	DOS	__KEEPPR


common_error:
	PRINTS	<'commonGAo^ł܂',$0d,$0a,0>
	DOS	__EXIT



common_image:
	.dc.b	'TTY#0001'
	.dc.l	__libc_tty
	.dc.l	__libc_ttywork
common_image_end:




;
; 풓ĂȂ   d0.l =  Ǘ|C^
; 풓ĂȂȂ d0.l =  0
;
keep_chk:
		movem.l	d1/a0-a3,-(sp)	; WX^ޔ

		DOS	__GETPDB
		movea.l	d0,a0
		lea.l	(-$10,a0),a0
		lea.l	(a0),a3

		; Ԍ̃ubN܂ňړ
@@:		tst.l	(12,a0)		; 0 ȂΈԂ
		beq	2f
		movea.l	(12,a0),a0	; 0 łȂA
		bra	@b


1:		move.l	(a0),d0		; ÕubN
					; d0.l = (a0) = $0000_0000 ȂA擪ubN
		beq	8f		; 擪܂ŗĂƂƂ́A풓ĂȂ
		movea.l	d0,a0		; d0 = a0 = Ǘptr

		; 풓vZXۂ̃`FbN
2:		cmpi.b	#$ff,(4,a0)	; 풓vZXȂA4(a0).l A$ff?????? ł
		bne	1b		; 풓vZXłȂBȂ

		; ID ̃`FbN
		lea.l	256+IDSIZE(a0),a1	; 풓 ID
		cmpa.l	($8,a0),a1		; MEMENDȏ̃ubN?
		bcc	1b			; IDSIZEɂȂ

		lea.l	(-IDSIZE,a1),a1
		lea.l	(ID,pc),a2	;  ID
		moveq.l	#IDSIZE-1,d0
@@:		cmpm.b	(a1)+,(a2)+	;  0 ` 3 oCg
		dbne	d0,@b
					; Z flg = 1 then IDv
		bne	1b		; ID 

					; 풓Ă
		move.l	a0,d1
		bra	9f

8:
		moveq.l	#0,d1		; Ǘ|C^̑ɁA0 ă^[

9:
		move.l	d1,d0
		movem.l	(sp)+,d1/a0-a3
		rts






.end	entry

