#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/dos.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>



#include <sys/termios.h>
#include <sys/tty.h>
extern	struct	tty	*_libc_tty_ptr;
extern	char _character_code_flag[256];



#define TXWRITEBUFSIZ 2048


unsigned char __xcase_type[128] = {
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
	0x00,0x02,0x02,0x02, 0x02,0x02,0x02,0x02, 0x02,0x02,0x02,0x02, 0x02,0x02,0x02,0x02,
	0x02,0x02,0x02,0x02, 0x02,0x02,0x02,0x02, 0x02,0x02,0x02,0x00, '\\',0x00,0x00,0x00,
	'\'',0x01,0x01,0x01, 0x01,0x01,0x01,0x01, 0x01,0x01,0x01,0x01, 0x01,0x01,0x01,0x01,
	0x01,0x01,0x01,0x01, 0x01,0x01,0x01,0x01, 0x01,0x01,0x01,'(',  '!', ')', '^' ,0x00
};





int write (int fileno, const char *buffer, unsigned int bytes)
{
	int cpos, rc, count;
	int eof, decr, flag;
	char *wp, *rp;
	char wbuf[TXWRITEBUFSIZ + 1 + 1];

	/* sȃt@Cnh`FbN */
	if (_writable (fileno) < 0) {
		errno = EBADF;
		return -1;
	}

	/* 0 oCgȂ牽sȂ */
	if (bytes <= 0)
		return 0;

	/* APPEND Ȃ΃t@C̍ŌɃV[N */
	if ((flag = _fddb[fileno].oflag) & O_APPEND) {
		if (_seekeof (fileno, flag) < 0)
			return -1;
	}


	/* R\[ւ̏ */
	if( isatty(fileno) ){

		/* cooked/raw ̊mF */
		if( (rc = _dos_ioctrlgt(fileno)) < 0){
			errno = _errcnv(rc);
			return -1;
		}

		/* cooked foCX ŁAo͕ϊKv */
		else if(!(rc & _DEV_RAW) &&
				(_libc_tty_ptr->t_oflag & OPOST ) ){

			static unsigned short kanji_in = 0;

			/* ϐ */
			rp = (char *) buffer;
			count = bytes;

			/* bytes  */
			while( 0 < bytes-- ){
				unsigned char c;
				c = *(unsigned char *)rp++;

				if( kanji_in ){
					/* 2byte  2byte ڂ͂ȂɂȂ */
					kanji_in = 0;
				}else{

					switch( _character_code_flag[c] ){
					case 0:
						if( c == '\n' && (_libc_tty_ptr->t_oflag & (ONLCR|ONLRET)) ){
							_dos_fputc('\r',fileno);
#ifdef OCRNL
						}else if( c == '\r' && (_libc_tty_ptr->t_oflag & OCRNL) ){
							c = '\n';
#endif
						}
						break;

					case 1:
						if( _libc_tty_ptr->t_lflag & XCASE ){
							switch( __xcase_type[c] ){
							case 0:
								break;
							case 1:
#ifdef OLCUC
								if( _libc_tty_ptr->t_oflag & OLCUC ){
									c = c - 'a' + 'A';
								}
#endif
								break;
							case 2:
								_dos_fputc('\\',fileno);
								break;
							default:
								_dos_fputc('\\',fileno);
								c = __xcase_type[c];
								break;
							}
#ifdef OLCUC
						}else if( _libc_tty_ptr->t_oflag & OLCUC ){
							if ( 'a' <= c && c <= 'z') {
								c = c - 'a' + 'A';
							}
#endif
						}
						break;

					case 2:
					case 3:
						kanji_in = 1;
						break;
					}
				}

				/* ʂɏ! */
				_dos_fputc(c,fileno);
			}

			return count;

		}

		/* raw foCXA͏o͕ϊ */
		else
			goto write_binary;
	}

	/* oCi[h̏ */
	else if (flag & O_BINARY) {

write_binary:
		/* oCi[hł͂ */
		if ((count = _dos_write (fileno, buffer, bytes)) < 0) {
			errno = _errcnv (count);
			return -1;
		}

		/* G[? */
		else if (count != bytes) {
			errno = ENOSPC;
			return -1;
		}

	}
	else {

		/* ϐ */
		decr = bytes;
		rp = (char *) buffer;
		wp = wbuf;
		eof = cpos = count = 0;

		/* IɂȂ܂ŏ */
		while (!eof) {

			/* LF->CR/LF ϊ */
			if (*rp == '\n') {
				*wp++ = '\r';
				cpos++;
			}

			/* obt@ɓ] */
			*wp++ = *rp++;
			cpos++;
			count++;

			/* SϊI EOF */
			if (--decr <= 0)
				eof = 1;

			/* obt@O */
			if (eof || cpos >= TXWRITEBUFSIZ) {

				/* obt@̓eo */
				if ((rc = _dos_write (fileno, wbuf, cpos)) < cpos) {

					/* SɃG[Ȃ... */
					if (rc < 0) {
						errno = _errcnv (rc);
						return -1;
					}

					/* łȂ... */
					else {

						/* ۂɏ񂾃oCgԂ */
						return count - cpos + rc;

					}

				}

				/* JE^ */
				cpos = 0;
				wp = wbuf;

			}

		}

	}

	/* ߂ */
	return count;
}
