#include <sys/dos.h>

#include "ttywork.h"

extern	struct	tty	*_libc_tty_ptr;
extern  struct	_ttywork	*_libc_ttywork_ptr;


struct _ttycom {
	unsigned long		id;
	unsigned long		ver;
	struct tty *		ttyptr;
	struct _ttywork *	ttyworkptr;
};


void _ttyinit()
{
	struct _ttycom ttycom;


	if( _dos_common_ck( "TTY" ) < 0 )
		return;

	_dos_common_rd( "TTY", 0, &ttycom, sizeof(ttycom) );
	if( ttycom.id  != 0x54545923 )
		return;


	if( ttycom.ver <  0x30303030 )
		return;
	_libc_tty_ptr = ttycom.ttyptr;


	if( ttycom.ver <  0x30303031 )
		return;

	_libc_ttywork_ptr = ttycom.ttyworkptr;



#if 0
	if( ttycom.ver <  0x30303032 )
		return;

	/*	new features (new version only)*/
#endif
}



