#include <sys/termios.h>
#include <sys/tty.h>
#include <sys/ioctl.h>

#include "ttywork.h"

#define	TTY_QUEUE_SIZE	2048
static char _raw_queue[TTY_QUEUE_SIZE];

struct	tty	_libc_tty = {
							/*	struct clist	*/
	0,							/*	int		c_cc;			*/
	TTY_QUEUE_SIZE, 			/*	int		c_cn;			*/
	_raw_queue,					/*	unsigned char	*c_cf;	*/
	_raw_queue,					/*	unsigned char	*c_cl;	*/
	_raw_queue,					/*	unsigned char	*c_cs;	*/
	&_raw_queue[TTY_QUEUE_SIZE], /*	unsigned char	*c_ce;	*/

	0,						/*	struct	pgrp *	*/

							/*	struct	winsize */
	0,							/*	unsigned short	ws_row; 	*/
	0,							/*	unsigned short	ws_col; 	*/
	0,							/*	unsigned short	ws_xpixel;	*/
	0,							/*	unsigned short	ws_ypixel;	*/

							/*	struct	termios */
	TTYDEF_IFLAG,				/*	tcflag_t	c_iflag;		*/
	TTYDEF_OFLAG,				/*	tcflag_t	c_oflag;		*/
	TTYDEF_CFLAG|TTYDEF_SPEED,	/*	tcflag_t	c_cflag;		*/
	TTYDEF_LFLAG,				/*	tcflag_t	c_lflag;		*/

								/*	cc_t		c_cc[NCCS]; 	*/

	CEOF,
	CEOL,
	CEOL,
	CERASE,
	CWERASE,
	CKILL,
	CREPRINT,
	_POSIX_VDISABLE,
	CINTR,
	CQUIT,
	CSUSP,
	CDSUSP,
	CSTART,
	CSTOP,
	CLNEXT,
	CDISCARD,
	CMIN,
	CTIME,
	CSTATUS,
	_POSIX_VDISABLE,

	TTYDEF_SPEED,				/*	long		c_ispeed;		*/
	TTYDEF_SPEED,				/*	long		c_ospeed;		*/


								/*	long	t_rawcc;	*/
	0

};



struct _ttywork _libc_ttywork = {
	NTTYDISC,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
	0,
};



